// -*- C++ -*-
/*!
 * @file  GPS_Class.cpp for PW
 * @date  $Date$
 *
 * $Id$
 */

#include "GPS_Class.h"
#include <cmath>
#include <fstream>
#include <iostream>

//n̔a`
const int ROFE=6378137;

//~`
const double PI=3.14159265;

/*
 *  Default Constructor
 */

GPS_Class::GPS_Class(void) {
	//ϐ
	this->mem_cal_dire = 0;
	this->mem_dire = 0;
	this->pase_count = 0;
}
 

/*
 *  Destructor
 */

GPS_Class::~GPS_Class(void) {
}
 

/*
 *  double GPS_Class::cal_rad_fromdeg(double)
 */
//ܓxCoxradiandegreeɕϊ
double GPS_Class::cal_rad_fromdeg(double degree) {

	double a = floor( degree / 100 );

	double b =  ( degree - a * 100 ) / 60;

	double radian = ( a + b ) * PI / 180;

	return radian;
}

/*
 *  double GPS_Class::cal_dist(double,double,double,double)
 */
//ƂܓxCoxԂ̋Zo
double GPS_Class::cal_dist(double lon1,double lat1,double lon2,double lat2) {
	double dlon = GPS_Class::cal_rad_fromdeg( lon2 ) - GPS_Class::cal_rad_fromdeg( lon1 );

	double dy = ROFE * dlon;

	double dlat = GPS_Class::cal_rad_fromdeg( lat2 ) - GPS_Class::cal_rad_fromdeg( lat1 );

	double dx = ROFE * dlat * cos( GPS_Class::cal_rad_fromdeg( lon2 ) );

	double dist = sqrt( dx * dx + dy * dy );

	return dist;
}

/*
 *  double GPS_Class::get_dist_tomap(int)
 */
//Ƃ}bvԍ̈ܓxoxƌ݈ʒuԂ̋Zo
double GPS_Class::get_dist_tomap(int map_nam) {
	//̌vZ
	double dist= GPS_Class::cal_dist( this->now_lon , this->now_lat , setA.map_lon[map_nam] , setA.map_lat[map_nam] );
	//f[^Ԃ
	return dist;
}

/*
 *  double GPS_Class::cal_dire(double,double,double,double)
 */
//Ƃܓxoẍ߂̓_߂̓_ւ̕ʂZo
double GPS_Class::cal_dire(double lon1,double lat1,double lon2,double lat2) {
	double dist = GPS_Class::cal_dist( lon1 , lat1 , lon2 , lat2 );

	//݈ʒuƖڕWʒüܓx̍ŎZo
	double dlon = GPS_Class::cal_rad_fromdeg( lon2 ) - GPS_Class::cal_rad_fromdeg( lon1 );

	double dy = ROFE * dlon;

	//pxZo
	double to_dire = acos( dy / dist );

	//ox̍Ȃ琳𔽓]
	if( (lat2 - lat1) < 0 )	to_dire = -1 * to_dire;

	//raddegreeɕϊ
	to_dire = to_dire * 180 / PI;

	//͈͂-180`180K0`360Kɕϊ
	if( to_dire < 0 ) to_dire = 360 + to_dire ;

	//acošʂ񐔒lłȂmF
	if( !(0 <= to_dire) && !(to_dire <= 360) ){
	//񐔒l̏ꍇ͑Ǒʂێ
		to_dire = this->mem_cal_dire;
	}
	else this->mem_cal_dire = to_dire;

	return to_dire;
}

/*
 *  double GPS_Class::get_dire(int)
 */
//݈ʒuƂ}bvԍ̈ܓxox܂ł̕ʂZo
double GPS_Class::get_dire(int map_nam) {
	//̌vZ
	double dist = GPS_Class::get_distance( map_nam );

	//݈ʒuƖڕWʒüܓx̍ŎZo
	double dlon = GPS_Class::cal_rad_fromdeg( setA.map_lon[ map_nam ] ) - GPS_Class::cal_rad_fromdeg( this->now_lon );

	double dy = ROFE * dlon;

	//px̌vZ
	double dire = acos( dy / dist );
	
	//݈ʒuƖړIňox̍
	double Dnow_lat = setA.map_lat[map_nam] - this->now_lat;

	//݈ʒuƖړIňox̍}CiXȂ
	if( Dnow_lat < 0){
		dire = -1 * dire;	
	}
	//raddegreeɕϊ
	dire = dire * 180 / PI;

	//͈͂-180`180K0`360Kɕϊ
	if( dire < 0 ) dire = 360 + dire ;

	//acošʂ񐔒lłȂmF
	if( !(0 <= dire) && !(dire <= 360) ){
	//񐔒l̏ꍇ͑Ǒʂێ
	dire = this->mem_dire;
	}
	else this->mem_dire = dire;

	return dire;
}

/*
 *  bool GPS_Class::set_mapArray(string filename)
 */
//w肳ꂽ}bṽ}bvf[^ǂݍ
bool GPS_Class::set_mapArray(std::string filename) {

	std::ifstream fin( filename.c_str() );
	char str[100];
	std::string fline , lon , lonNS , lat , latEW , ren;
	int mapnum = 0;
	int NS = 0;
	int EW = 0;

	if( fin.is_open() ){

		while( !fin.eof() ){

			fin.getline( str , 99 );
			if( !fin.eof() ) fline.append( str );
			else break;

			if( fline.find( "//" ) == std::string::npos && fline.find( "MAP_END" ) != std::string::npos )
				break;

			else if( fline.find( "//" ) == std::string::npos ){
				
				lon = fline.substr( 0 , fline.find(',') );

				fline.erase( 0 , fline.find( ',' ) + 1 );
				lonNS = fline.substr( 0 , fline.find(',') );

				fline.erase( 0 , fline.find( ',' ) + 1 );
				lat = fline.substr( 0 , fline.find(',') );

				fline.erase( 0 , fline.find( ',' ) + 1 );
				latEW = fline.substr( 0 , fline.find(',') );

				fline.erase( 0 , fline.find( ',' ) + 1 ); 
				ren = fline.substr( 0 ,  fline.find(',') );

				//씼ł͈ܓx𔽓]
				if( lonNS.find( "N" ) == std::string::npos )
					NS = -1;
				else NS = 1; 

				//ł͌ox𔽓]
				if( latEW.find( "E" ) == std::string::npos )
					EW = -1;
				else EW = 1;

				setA.map_lon[ mapnum ] = NS * atof( lon.c_str() );
				setA.map_lat[ mapnum ] = EW * atof( lat.c_str() );
				setA.map_reng[ mapnum ] = atof( ren.c_str() );

				mapnum++;
			}

			fline.erase( 0 , fline.length() );

		}
		fin.close();

		setA.map_num = mapnum;

		setA.map_lon[ mapnum ] = setA.map_lon[ mapnum - 1 ];
		setA.map_lat[ mapnum ] = setA.map_lat[ mapnum - 1 ];
		setA.map_reng[ mapnum ] = setA.map_reng[ mapnum - 1 ];

		return true;
	}

	else return false;
}

/*
 *  double GPS_Class::get_degree(int map_nam)
 */
//Ƃ}bvԍ̃}bv܂ł̐pxZo
double GPS_Class::get_degree(int map_nam) {
	double terg_dire;
	double out_dire;

	terg_dire = GPS_Class::get_dire( map_nam );

	//ݕʂƖڕWʂ̍񂷂px
	out_dire = terg_dire - this->aft_dire;
	
	//̒l()͐̒l(E)ɕϊ
	if( out_dire < 0 ) out_dire = out_dire + 360;

	return out_dire;
}

/*
 *  double GPS_Class::get_distance(int map_nam)
 */
//Ƃ}bvԍ̃}bv܂ł̐pxZo
double GPS_Class::get_distance(int map_nam) {
	double out_dist;

	out_dist = GPS_Class::get_dist_tomap( map_nam );

	return out_dist;
}


int GPS_Class::get_map_number( void ){


	return this->setA.map_num;

}


/*
 *  void GPS_Class::bef_set(void)
 */
//ړÖܓxoxL^
void GPS_Class::bef_set(void) {
	this->bef_lon = this->now_lon;
	this->bef_lat = this->now_lat;
}

/*
 *  void GPS_Class::aft_set(void)
 */
//ړ̈ܓxoxL^Cԑ̂̐isZo
void GPS_Class::aft_set(void) {
	this->aft_lon = this->now_lon;
	this->aft_lat = this->now_lat;

	this->aft_dist = GPS_Class::cal_dist( this->bef_lon , this->bef_lat , this->aft_lon , this->aft_lat );
	this->aft_dire = GPS_Class::cal_dire( this->bef_lon , this->bef_lat , this->aft_lon , this->aft_lat );
}

/*
 *  void GPS_Class::gpsReceive(const char *str)
 */
//񂩂GPS擾
void GPS_Class::gpsReceive(const char *str) {

	double now_lon_check , now_lat_check;

	std::string text, text2, text3, TempText;
	std::string::size_type length1, length2, length3 , i;

	GPSData.LogStr.append(str);


	if( GPSData.LogStr.find( "\n" ) != std::string::npos )
		GPSData.LogStr.replace( GPSData.LogStr.find( "\n" ) , 1 , "" );


	length1 = GPSData.LogStr.find( "$" );
	length2 = GPSData.LogStr.find("*");

	if((length1 != std::string::npos ) && (length2 != std::string::npos ))
	{
		if (length1 > length2)
		{
			GPSData.LogStr = GPSData.LogStr.substr( length1 );
			//
			TempText = GPSData.LogStr;
		}
		else
		{
			TempText = GPSData.LogStr.substr( length1 );
			for(i=0; i<14; i++)
			{	
				length3 = TempText.find(",");
				GPSData.Data[i] = TempText.substr( 0 , length3 );
				TempText = TempText.substr(length3 + 1);
			}
			length3 = TempText.find("*");
			GPSData.Data[i] = TempText.substr( 0 , length3 );
			TempText = TempText.substr(length3);
			i++;
			length3 = TempText.find("\r\n");
			GPSData.Data[i] = TempText.substr( 0 , length3 );
			GPSData.LogStr = GPSData.LogStr.substr(length2 + 1);

			GPSData.LogStr.erase( 0 , GPSData.LogStr.length() );


			//vZpdoubleɕϊ
			if( GPS_Class::debug_atof( GPSData.Data[2].c_str() ) && GPS_Class::debug_atof( GPSData.Data[4].c_str() ) && GPSData.Data[0].find( "GGA" ) != std::string::npos ){
				now_lon_check = atof( GPSData.Data[2].c_str() );

				if( now_lon_check < 9000 && now_lon_check > 0 )
				{
					this->now_lon = atof( GPSData.Data[2].c_str() );
					//씼ł͈ܓx𔽓]
					if( GPSData.Data[ 3 ].find( "N" ) == std::string::npos && GPSData.Data[ 3 ].find( "S" ) >= 0 )
						this->now_lon = -1 * this->now_lon;
					this->pase_count++;
					if( this->pase_count >= 10 ){
						this->pase_count = 0;
					}
				}

				now_lat_check = atof( GPSData.Data[4].c_str() );

				if( now_lat_check < 18000 && now_lat_check > 0 )
				{
					this->now_lat = atof( GPSData.Data[4].c_str() );
					//ł͌ox𔽓]
					if( GPSData.Data[ 5 ].find( "E" ) == std::string::npos && GPSData.Data[ 5 ].find( "W" ) >= 0 )
						this->now_lat = -1 * this->now_lat;
				}
			}

		}
	}

}

/*
 *  bool GPS_Class::debug_atof( const char *double_from )
 */
//ɐƏ_ȊÕf[^ĂȂmF
bool GPS_Class::debug_atof( const char *double_from ){
	int i, len;
	len = strlen( double_from );
	for (i = 0 ; i < len ; i++) {
		if ( isalnum((unsigned char)double_from[i]) == 0 && double_from[i] != '.' ) {
			return false;
		}
	}
	return true;
}

/*
 *  bool GPS_Class::moving(double jdis)
 */
//ƂCbef_set_ړtrue
bool GPS_Class::moving(double dist) {
	double dist_moved;

	dist_moved = GPS_Class::cal_dist( this->bef_lon , this->bef_lat , this->now_lon , this->now_lat );

	if( dist < dist_moved ) return true;

	else return false;
}

/*
 *  bool GPS_Class::switch_map(int map_nam)
 */
//Ƃ}bvԍ̈ܓxoxɁC}bvf[^Ŏw肵l̋߂Â^Ԃ
bool GPS_Class::switch_map(int map_nam) {
	double dist = GPS_Class::cal_dist( this->now_lon , this->now_lat , setA.map_lon[map_nam] , setA.map_lat[map_nam] );
	
	if( dist < setA.map_reng[map_nam] )
		return true;

	else return false;
}

//ܓx擾
double GPS_Class::get_lon(){

	return this->now_lon;

}

//ox擾
double GPS_Class::get_lat(){

	return this->now_lat;

}