// -*- C++ -*-
/*!
 * @file  GPS_Class.h for PW
 * @date  $Date$
 *
 * $Id$
 */

#ifndef GPS_CLASS_H
#define GPS_CLASS_H

#include <string>
#include <iostream>

//}bv\
typedef struct {
	std::string l;
	std::string LogStr;
	int map_num;
	double map_lon[5000];
	double map_lat[5000];
	double map_dire[5000];
	double map_reng[5000];
} MAP;

//M𕪊Ċi[镶ƕz
typedef struct {
	std::string LogStr;
	std::string Data[16];
} GPSGGA;

class GPS_Class
{
  private:
  // <rtc-template block="private_attribute">
    double now_lon;			//݂̈ܓxϐ
    double now_lat;			//݂̌oxϐ
    double bef_lon;			//ړÖܓxϐ
    double bef_lat;			//ړǑoxϐ
    double aft_lon;			//ړ̈ܓxϐ
    double aft_lat;			//ړ̌oxϐ
    double aft_dire;		//ړɎZois̕
    double aft_dist;		//ړɎZoړ
    GPSGGA GPSData;			//MNMEA-0183ZeX𕪊Ċi[镶ƕz
    double mem_cal_dire;	//֐cal_diresɊpxL^Ăϐ(cal_diresɌʂ񐔒l̂Ƃp)
    double mem_dire;		//֐get_diresɊpxL^Ăϐ(get_diresɌʂ񐔒l̂Ƃp)

  // </rtc-template>

  // <rtc-template block="private_operation">
    double cal_rad_fromdeg(double degree);								//ܓxCoxradiandegreeɕϊ
    double cal_dist(double lon1 ,double lat1,double lon2,double lat2);	//ƂܓxCoxԂ̋Zo
    double get_dist_tomap(int map_nam);									//Ƃ}bvԍ̈ܓxoxƌ݈ʒuԂ̋Zo
    double cal_dire(double lon1,double lat1,double lon2,double lat2);	//Ƃܓxoẍ߂߂̓_ւ̕ʂZo
	double get_dire(int map_nam);										//݈ʒuƂ}bvԍ̈ܓxox܂ł̕ʂZo
	bool debug_atof( const char *double_from );							//ɐƏ_ȊÕf[^ĂȂmF
  // </rtc-template>

  protected:
  // <rtc-template block="protected_attribute">
  // </rtc-template>

  // <rtc-template block="protected_operation">
  // </rtc-template>

  public:
    GPS_Class();								//RXgN^
    virtual ~GPS_Class();						//fXgN^
  // <rtc-template block="public_attribute">
  // </rtc-template>

  // <rtc-template block="public_operation">
	bool set_mapArray(std::string filename);	//Ƃt@C̃}bvf[^̓ǂݍ
    double get_degree(int map_nam);				//ڕW_܂ł̐pxԂ
    double get_distance(int map_nam);			//ڕW_܂ł̋Ԃ
	int get_map_number( void );					//[h}bv̌oR_̐Ԃ
    void bef_set(void);							//ړÖʒuݒ肷
    void aft_set(void);							//ړ̈ʒuݒ肵CisƈړZo
	void gpsReceive(const char *str);			//NEMA-0183Kȉ𕶎œ
    bool moving(double dist);					//ݒ肵bef_set_ړ^Ԃ
    bool switch_map(int map_nam);				//ڕW_փ}bvŐݒ肵߂Â^Ԃ

	double get_lon();							//ړ擾
	double get_lat();							//ox擾

	int pase_count;								//ܓxoxXV+1

	MAP setA;									//}bvf[^
  // </rtc-template>
};

#endif // GPS_CLASS_H
